<?php
function qbank_admin_settings() {
  $form['qbank_admin_settings'] = array(
    '#type' => 'vertical_tabs',
  );

  $form['qbank_configuration'] = array(
    '#type' => 'fieldset',
    '#title' => t('Configuration'),
    '#collapsible' => TRUE,
    '#description' => t('Vaules needed to connect with QBank'),
    '#group' => 'qbank_admin_settings'
  );
  $form['qbank_configuration']['qbank_api_protocol'] = array(
    '#type' => 'select',
    '#title' => t('Protocol'),
    '#default_value' => variable_get('qbank_api_protocol', 'http'),
    '#options' => array(
      'http' => t('HTTP'),
      'https' => t('HTTPS'),
    ),
    '#required' => TRUE,
  );
  $form['qbank_configuration']['qbank_api_url'] = array(
    '#type' => 'textfield',
    '#title' => t('API Url'),
    '#default_value' => variable_get('qbank_api_url'),
    '#required' => TRUE,
  );
  $form['qbank_configuration']['qbank_client_id'] = array(
    '#type' => 'textfield',
    '#title' => t('Client ID'),
    '#default_value' => variable_get('qbank_client_id'),
    '#required' => TRUE,
  );
  $form['qbank_configuration']['qbank_api_user'] = array(
    '#type' => 'textfield',
    '#title' => t('User'),
    '#default_value' => variable_get('qbank_api_user'),
    '#required' => TRUE,
  );
  $form['qbank_configuration']['qbank_api_pass'] = array(
    '#type' => 'textfield',
    '#title' => t('Password'),
    '#default_value' => variable_get('qbank_api_pass'),
    '#required' => TRUE,
  );
  $form['qbank_configuration']['qbank_session_id'] = array(
    '#type' => 'textfield',
    '#title' => t('Session ID'),
    '#default_value' => variable_get('qbank_session_id'),
    '#required' => TRUE,
  );
  $form['qbank_configuration']['qbank_deployment_site'] = array(
    '#type' => 'select',
    '#title' => t('Deployment site'),
    '#options' => get_deployment_sites(),
    '#default_value' => variable_get('qbank_deployment_site'),
    '#required' => FALSE,
  );

  $form['qbank_trial'] = array(
    '#type' => 'fieldset',
    '#title' => t('Trial account'),
    '#collapsible' => TRUE,
    '#description' => t('Generate trial account for free'),
    '#group' => 'qbank_admin_settings'
  );
  $form['qbank_trial']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Generate'),
    '#submit' => array('qbank_generate_submit'),
  );

  return system_settings_form($form);
}

/**
 * Implements hook_form_FORM_ID_alter().
 */
function qbank_dam_form_qbank_admin_settings_alter(&$form, &$form_state, $form_id) {
  $form['#submit'][] = '_qbank_admin_settings_form_submit';
}

function _qbank_admin_settings_form_submit($form_id, &$form_state){
  $token = _get_token_credentials(
    $form_state['values']['qbank_client_id'],
    $form_state['values']['qbank_api_user'],
    $form_state['values']['qbank_api_pass'],
    $form_state['values']['qbank_api_url']
  );
  
  if (!($token)) {
    form_set_error('token', 'No connection to API, check your data');
  }
  else {
    variable_set('qbank_token', $token->accessToken);
    variable_set('qbank_token_expires', $token->expires);
  }
}