<?php

/**
 * Implements hook_ckeditor_plugin().
 */
function qbank_dam_ckeditor_plugin() {
  return array(
    'qbank' => array(
      'name' => 'QBank',
      'desc' => 'QBank ckeditor integration',
      'path' => drupal_get_path('module', 'qbank_dam') . '/js/',
      'buttons' => array(
        'QBank' => array(
          'icon' => '../img/icon-ckeditor.png',
          'label' => 'QBank',
        ),
      ),
    ),
  );
}

/**
 * Implements hook_field_widget_WIDGET_TYPE_form_alter().
 */
function qbank_dam_field_widget_text_textarea_with_summary_form_alter(
  &$element,
  &$form_state,
  $context
) {
  if (!(_check_config())) {
    drupal_set_message(t('Your QBank configuration is incomplete. Please go to <a href="!url">configuration page</a>.',
      array('!url' => url('/admin/config/media/qbank'))), 'status', FALSE);
    return;
  }

  $element['#attached']['js'][] = array(
    'type' => 'external',
    'data' => variable_get('qbank_api_protocol',
        'http') . '://' . variable_get('qbank_api_url') . '/connector/qbank-connector.min.js',
  );

  $modulePath = drupal_get_path('module', 'qbank_dam');
  $form['#attached']['js'][] = array(
    'type' => 'file',
    'data' => $modulePath . '/js/plugin.js',
  );

  $html_id = 'qbank-ckeditor-wrapper' . rand();

  $element['#attached']['js'][] = array(
    'type' => 'setting',
    'data' => array(
      'qbank' => array(
        'token' => _get_token(),
        'url' => variable_get('qbank_api_url'),
        'html_id' => $html_id,
        'deployment_site' => variable_get('qbank_deployment_site', 0),
        'protocol' => variable_get('qbank_api_protocol', 'http'),
        'modulePath' => $modulePath,
      )
    ),
  );
}
