(function ($) {
    Drupal.behaviors.qbank = {
        attach: function (context, settings) {
            var mediaSelected = function (media, image) {
                $('.media-add-from-qbank-url').val(image[0].url);
                $('.media-add-from-qbank-filename').val(media.filename);
                $('.media-add-from-qbank-extension').val(media.extension);
                $('.media-add-from-qbank-title').val(media.name);
                $('.media-add-from-qbank-media_id').val(media.mediaId);
                $('.qbank-connector-wrapper').empty();
                $('.qbank-connector-wrapper').append('<img id="qbank-image-loading" style="position:absolute;top:0;bottom:0;margin:auto;left: 0;right: 0;" src=/' + Drupal.settings.qbank.modulePath + '/img/ajax-loader.gif>');
                $('form#qbank-file-add-form').submit();
            };

            var pickerClosed = function() {
                jQuery('#qbank-image-loading').remove();
                return true;
            };

            var qbcConfig = {
                deploymentSite: Drupal.settings.qbank.deployment_site,
                api: {
                    host: Drupal.settings.qbank.url,
                    access_token: Drupal.settings.qbank.token,
                    protocol: Drupal.settings.qbank.protocol
                },
                gui: {
                    basehref: Drupal.settings.qbank.protocol + '://' + Drupal.settings.qbank.url + '/connector/'
                }
            };

            QBC = new QBankConnector(qbcConfig);
            mediaPicker = new QBC.mediaPicker({
                container: '#' + Drupal.settings.qbank.html_id,
                onSelect: mediaSelected,
                onClose: pickerClosed,
                modules: {
                    folders: true,
                    categories: true,
                    moodboards: true,
                    settings: true,
                    content: {
                        header: false,
                        toolbar: true,
                        details: true
                    },
                    imageTool: {
                        crop: true
                    },
                    detail: {
                        showUseButton: true
                    },
                    searchResult: {
                        showUseButton: false
                    }
                }
            });

            // Resize QBank iframe
            $('.qbank-connector-wrapper').css('height', ($(window).height() - 80) + 'px' );
            $(window).resize(function() {
                $('.qbank-connector-wrapper').css('height', ($(window).height() - 80) + 'px' );
            });
        }
    };
})(jQuery);